<script setup lang="ts">
import type { Permission } from '~/models/role'
import { permissions } from '~/const/page-permission/ambulatory'
import Error from '~/components/pub/my-ui/error/error.vue'

import Content from '~/components/content/encounter/entry.vue'

definePageMeta({
  middleware: ['rbac'],
  roles: ['emp|reg'],
  title: 'Tambah Kunjungan',
  contentFrame: 'cf-full-width',
})

// Preps role checking
const roleAccess: Record<string, Permission[]> = permissions['/outpatient/encounter'] || {}
const { checkRole, hasReadAccess, hasCreateAccess } = useRBAC()

// Check if user has access to this page
const hasAccess = checkRole(roleAccess)
if (!hasAccess) {
  navigateTo('/403')
}

// Define permission-based computed properties
const canRead = hasReadAccess(roleAccess)

// Page needs
const route = useRoute()
useHead({
  title: () => route.meta.title as string,
})

// Define permission-based computed properties
const canCreate = hasCreateAccess(roleAccess)
</script>

<template>
  <div v-if="canCreate">
    <Content
      :id="0"
      class-code="ambulatory"
      sub-class-code="chemo"
      form-type="Tambah"
    />
  </div>
  <Error
    v-else
    :status-code="403"
  />
</template>
